import * as reflect from 'jsii-reflect';
import { IntrinsicExpression, TemplateExpression } from '../parser/template';
export interface AnyTemplateExpression {
    readonly type: 'any';
    readonly value: TemplateExpression;
}
export declare function resolveAnyExpression(x: TemplateExpression): AnyTemplateExpression;
export declare function isAny(typeRef: reflect.TypeReference): boolean;
export interface VoidExpression {
    readonly type: 'void';
}
export declare function assertVoid(x: unknown): void;
export declare function resolveVoidExpression(): VoidExpression;
export declare function assertLiteralOrIntrinsic<T extends 'string' | 'number' | 'boolean'>(x: TemplateExpression, type: T): (TemplateExpression & {
    type: T;
}) | IntrinsicExpression;
