import { TypedTemplateExpression } from './expression';
import { GetPropIntrinsic, RefIntrinsic, TemplateExpression } from '../parser/template';
export interface ResolveReferenceExpression {
    type: 'resolve-reference';
    reference: RefIntrinsic | GetPropIntrinsic;
}
export declare function resolveRefToValue(x: RefIntrinsic): ResolveReferenceExpression;
export declare function assertRef(x: TemplateExpression): RefIntrinsic;
export declare function refOrResolve(x: TemplateExpression, fn: (x: TemplateExpression) => TypedTemplateExpression): TypedTemplateExpression;
