import * as cdk from 'aws-cdk-lib';
import * as reflect from 'jsii-reflect';
import { Template } from './parser/template';
export interface DeclarativeStackProps extends cdk.StackProps {
    typeSystem: reflect.TypeSystem;
    template: Template;
    workingDirectory?: string;
}
export declare class DeclarativeStack extends cdk.Stack {
    constructor(scope: cdk.App, id: string, props: DeclarativeStackProps);
    private addAnalyticsData;
}
