import { SchemaContext } from './jsii2schema';
export declare function schemaForIntrinsicFunctions(ctx: SchemaContext): void;
interface IntrinsicDefinition {
    description: string;
    variadic?: [number, number];
    params: ParameterDefinition[];
}
export declare function schemaForIntrinsic(name: string, def: IntrinsicDefinition): {
    type: string;
    properties: {
        [x: string]: any;
    };
    additionalProperties: boolean;
};
interface ParameterDefinition {
    name: string;
    description: string;
    optional?: boolean;
    types: any[];
}
export {};
